%% load data

clc; clear all; close all;

% [d,h] = load_sto('./simple_motion_states.sto');
% [d4,h4] = xlsread('./Runner18_initstates.xlsx');
[d3,h3] = load_sto('./simple_motion_Actuation_force.sto');
% [d5,h5] = load_sto('./simple_motion_ForceReporter_forces.sto');
[d6,h6] = load_sto('./simple_motion_pErr.sto');
[d7,h7] = load_sto('./inverse_dynamics.sto');
% [d8,h8] = load_sto('Z:\Research_Projects\Schmitz\KneeModel\Detailed_Knee_Model\Passive_Flexion\inverse_dynamics.sto');
% [d9,h9] = load_mot('Z:\Research_Projects\Schmitz\KneeModel\Detailed_Knee_Model\Passive_Flexion\flexion_ang.mot');
[d10,h10] = load_sto('./simple_motion_MuscleAnalysis_Moment_knee_angle_r.sto');
[d11,h11] = load_sto('./simple_motion_MuscleAnalysis_PassiveFiberForce.sto');
[d12,h12] = load_sto('./simple_motion_MuscleAnalysis_NormalizedFiberLength.sto');
[d13,h13] = load_sto('./Runner18_StaticOptimization_force.sto');
[d14,h14] = load_sto('./simple_motion_controls.sto');
[d15,h15] = load_sto('./simple_motion_MuscleAnalysis_ActiveFiberForce.sto');
[d16,h16] = load_sto('./Runner18_SOMuscleAnalysis_Moment_knee_angle_r.sto');

%% get times

t_cut = 0.23;

t3 = d3(:,strcmp(h3,'time'));
ii3 = find(t3>t_cut);
tt3 = t3(ii3);

t6 = d6(:,strcmp(h6,'time'));
ii6 = find(t6>t_cut);
tt6 = t6(ii6);

t7 = d7(:,strcmp(h7,'time'));
ii7 = find(t7>t_cut);
tt7 = t7(ii7);

t10 = d10(:,strcmp(h10,'time'));
ii10 = find(t10>t_cut);
tt10 = t10(ii10);

t11 = d11(:,strcmp(h11,'time'));
ii11 = find(t11>t_cut);
tt11 = t11(ii11);

t12 = d12(:,strcmp(h12,'time'));
ii12 = find(t12>t_cut);
tt12 = t12(ii12);

t13 = d13(:,strcmp(h13,'time'));
ii13 = find(t13>t_cut);
tt13 = t13(ii13);

t14 = d14(:,strcmp(h14,'time'));
ii14 = find(t14>t_cut);
tt14 = t14(ii14);

t15 = d15(:,strcmp(h15,'time'));
ii15 = find(t15>t_cut);
tt15 = t14(ii15);

t16 = d16(:,strcmp(h16,'time'));
ii16 = find(t16>t_cut);
tt16 = t16(ii16);

%% check kinematics

k_ang_error = d6(ii6,strcmp(h6,'knee_angle_r'));

figure('color','w','units','normalized','outerposition',[0 0 1 1]);

plot(tt6,k_ang_error*180/3.14,'r:','LineWidth',3);
hold on;
set(gca,'box','off','FontSize',14);
xlabel('Time (s)');
ylabel('Angle (deg)');
title('CMC Knee Angle Tracking Error');

saveas(gcf,'kinematics.fig');

%% check passive forces and fiber lengths

m_names = {'bifemlh_r';
    'bifemsh_r';
    'grac_r';
    'lat_gas_r';
    'med_gas_r';
    'sar_r';
    'semimem_r';
    'semiten_r';
    'rect_fem_r';
    'vas_int_r';
    'vas_lat_r';
    'vas_med_r'};

figure('color','w','units','normalized','outerposition',[0 0 1 1]);

l_type = {'r-','k-','g-','b-',...
          'r:','k:','g:','b:',...
          'r.','k.','g.','b.'};

for i = 1:size(m_names,1);
    subplot(2,1,1);
    hold on;
    plot(tt11,d11(ii11,strcmp(h11,m_names{i,1})),l_type{1,i},'LineWidth',3);
    l_string{i} = m_names{i,1};
    
    subplot(2,1,2);
    hold on;
    plot(tt12,d12(ii12,strcmp(h12,m_names{i,1})),l_type{1,i},'LineWidth',3);
end

xlabel('Time (s)');
ylabel('Normalized Muscle Fiber Length (-)');

subplot(2,1,1);
legend(l_string);
xlabel('Time (s)');
ylabel('Passive Muscle Force (N)');

saveas(gcf,'muscles.fig');

%% more muscles

figure('color','w','units','normalized','outerposition',[0 0 1 1]);

for i = 1:size(m_names,1);
    subplot(3,1,1);
    hold on;
    plot(tt14,d14(ii14,strcmp(h14,m_names{i,1})),l_type{1,i},'LineWidth',3);
    l_string{i} = m_names{i,1};
    set(gca,'box','off','FontSize',12);
    xlabel('Time (s)');
    ylabel('Activation (-)');
    
    subplot(3,1,2);
    hold on;
    plot(tt15,d15(ii15,strcmp(h15,m_names{i,1})),l_type{1,i},'LineWidth',3);
    set(gca,'box','off','FontSize',12);
    xlabel('Time (s)');
    ylabel('Active Fiber Force (-)');
    
    subplot(3,1,3);
    hold on;
    plot(tt10,d10(ii10,strcmp(h10,m_names{i,1})),l_type{1,i},'LineWidth',3);
    set(gca,'box','off','FontSize',12);
    xlabel('Time (s)');
    ylabel('Knee Flexion Torque (Nm)');
end
legend(l_string);

saveas(gcf,'muscles2.fig');

%% knee torques

k_RA = d3(ii3,strcmp(h3,'knee_angle_reserve'));
k_ID = d7(ii7,strcmp(h7,'knee_angle_r_moment'));

k_muscle = d10(ii10,2:end);
muscle_torq = sum(k_muscle,2);

k_RA_SO = d13(ii13,strcmp(h13,'knee_angle_reserve'));
k_muscle_SO = d16(ii16,2:end);
muscle_torq_SO = sum(k_muscle_SO,2);

figure('color','w','units','normalized','outerposition',[0 0 1 1]);

subplot(1,2,1);
plot(tt3,k_RA,'r:','LineWidth',3);
hold on;
plot(tt7,k_ID,'b-','LineWidth',3);
hold on;
plot(tt10,muscle_torq,'k-.','LineWidth',3);
hold on;
plot(tt10,muscle_torq+k_RA,'g-.','LineWidth',3);
set(gca,'box','off','FontSize',14);
legend('CMC Reserve Actuator','Inverse Dynamics','CMC Total Muscle Torque','CMC Muscle + CMC Reserve Actuator Torque');
xlabel('Time (s)');
ylabel('Torque (Nm)');
title('CMC Results');

subplot(1,2,2);
plot(tt13,k_RA_SO,'r:','LineWidth',3);
hold on;
plot(tt7,k_ID,'b-','LineWidth',3);
hold on;
plot(tt16,muscle_torq_SO,'k-.','LineWidth',3);
hold on;
plot(tt13,muscle_torq_SO+k_RA_SO,'g-.','LineWidth',3);
set(gca,'box','off','FontSize',14);
xlabel('Time (s)');
ylabel('Torque (Nm)');
title('Static Optimization Results');
legend('SO Reserve Actuator','Inverse Dynamics','SO Total Muscle Torque','SO Muscle + SO Reserve Actuator Torque');

saveas(gcf,'torque.fig');