%% load data

clc; clear all; close all;

[d,h] = load_sto('../Hinge/simple_motion_states.sto');
% % [d4,h4] = xlsread('./Runner18_initstates.xlsx');
% [d3,h3] = load_sto('./simple_motion_Actuation_force.sto');
[d5,h5] = load_sto('./Runner18_ForceReporter_forces.sto');
% [d6,h6] = load_sto('./simple_motion_pErr.sto');
% [d7,h7] = load_sto('./inverse_dynamics.sto');
% % [d8,h8] = load_sto('Z:\Research_Projects\Schmitz\KneeModel\Detailed_Knee_Model\Passive_Flexion\inverse_dynamics.sto');
% % [d9,h9] = load_mot('Z:\Research_Projects\Schmitz\KneeModel\Detailed_Knee_Model\Passive_Flexion\flexion_ang.mot');
% [d10,h10] = load_sto('./simple_motion_MuscleAnalysis_Moment_knee_angle_r.sto');
% [d11,h11] = load_sto('./simple_motion_MuscleAnalysis_PassiveFiberForce.sto');
% [d12,h12] = load_sto('./simple_motion_MuscleAnalysis_NormalizedFiberLength.sto');
% [d13,h13] = load_sto('./Runner18_StaticOptimization_force.sto');
% [d14,h14] = load_sto('./simple_motion_controls.sto');
% [d15,h15] = load_sto('./simple_motion_MuscleAnalysis_ActiveFiberForce.sto');
[d16,h16] = load_sto('./Runner18_states.sto');

%% get times

t_cut = 0.23;

t = d(:,strcmp(h,'time'));
ii = find(t>t_cut);
tt = t(ii);

t5 = d5(:,strcmp(h5,'time'));
ii5 = find(t5>t_cut);
tt5 = t5(ii5);

t16 = d16(:,strcmp(h16,'time'));
ii16 = find(t16>t_cut);
tt16 = t16(ii16);

%% kinematics

sf = 1.134;
k_add = 0;
k_int = 0;
k_tz = 0;
k_tx = [-2.0944 -1.74533 -1.39626 -1.0472 -0.698132 -0.349066 -0.174533 0.197344 0.337395 0.490178 1.52146 2.0944;
		-0.0032 0.00179 0.00411 0.0041 0.00212 -0.001 -0.0031 -0.005227 -0.005435 -0.005574 -0.005435 -0.00525];
k_ty = [-2.0944 -1.22173 -0.523599 -0.349066 -0.174533 0.159149 2.0944;
		-0.4226 -0.4082 -0.399 -0.3976 -0.3966 -0.395264 -0.396];
    
k_flex_m = (180/3.14)*d16(ii16,strcmp(h16,'knee_angle_r'));
k_add_m = (180/3.14)*d16(ii16,strcmp(h16,'knee_add_r'));
k_int_m = (180/3.14)*d16(ii16,strcmp(h16,'knee_rot_r'));
k_tx_m = d16(ii16,strcmp(h16,'knee_tx_r'));
k_ty_m = d16(ii16,strcmp(h16,'knee_ty_r'));
k_tz_m = d16(ii16,strcmp(h16,'knee_tz_r'));

k_ang = (180/3.14)*d(ii,strcmp(h,'knee_angle_r'));
k_tx2 = sf*interp1(k_tx(1,:)*(180/3.14),k_tx(2,:),k_ang);
k_ty2 = sf*interp1(k_ty(1,:)*(180/3.14),k_ty(2,:),k_ang);
    
figure('color','w','units','normalized','outerposition',[0 0 1 1]);

subplot(3,2,1);
plot(tt,k_ang,'b-','LineWidth',3);
hold on;
plot(tt16,k_flex_m,'r:','LineWidth',3);
set(gca,'box','off','FontSize',12);
set(gca,'XTickLabel',{' '});
ylabel('Angle (deg)');
title('Knee Flexion');
ylim([-55 6]);

subplot(3,2,3);
line([min(tt16) max(tt16)],[k_add k_add],'LineWidth',3,'Color','b');
hold on;
plot(tt16,k_add_m,'r:','LineWidth',3);
set(gca,'box','off','FontSize',12);
set(gca,'XTickLabel',{' '});
ylabel('Angle (deg)');
title('Knee Adduction');
ylim([-55 6]);

subplot(3,2,5);
line([min(tt16) max(tt16)],[k_int k_int],'LineWidth',3,'Color','b');
hold on;
plot(tt16,k_int_m,'r:','LineWidth',3);
set(gca,'box','off','FontSize',12);
xlabel('Time (s)');
ylabel('Angle (deg)');
title('Knee Internal Rotation');
ylim([-55 6]);

subplot(3,2,2);
plot(tt,k_tx2,'b-','LineWidth',3);
hold on;
plot(tt16,k_tx_m,'r:','LineWidth',3);
set(gca,'box','off','FontSize',12);
set(gca,'XTickLabel',{' '});
ylabel('Translation (m)');
title('Anterior Knee Translation');
legend('Hinge','Serial');
y2 = ylim;
y2_mid = mean(y2);
y2_range = max(y2)-min(y2);

subplot(3,2,4);
plot(tt,k_ty2,'b-','LineWidth',3);
hold on;
plot(tt16,k_ty_m,'r:','LineWidth',3);
set(gca,'box','off','FontSize',12);
set(gca,'XTickLabel',{' '});
ylabel('Translation (m)');
title('Superior Knee Translation');
y4 = ylim;
y4_mid = mean(y4);
y4_range = max(y4)-min(y4);

subplot(3,2,6);
line([min(tt16) max(tt16)],[k_tz k_tz],'LineWidth',3,'Color','b');
hold on;
plot(tt16,k_tz_m,'r:','LineWidth',3);
set(gca,'box','off','FontSize',12);
xlabel('Time (s)');
ylabel('Translation (m)');
title('Lateral Knee Translation');
y6 = ylim;
y6_mid = mean(y6);
y6_range = max(y6)-min(y6);

max_range = max([y2_range y4_range y6_range]);

subplot(3,2,2);
ylim([y2_mid-0.5*max_range y2_mid+0.5*max_range]);

subplot(3,2,4);
ylim([y4_mid-0.5*max_range y4_mid+0.5*max_range]);

subplot(3,2,6);
ylim([y6_mid-0.5*max_range y6_mid+0.5*max_range]);

saveas(gcf,'./serial_kinematics.fig');

%% cartilage forces

mFX = d5(ii5,strcmp('medial_tf.femur_r.force.X',h5));
mFY = d5(ii5,strcmp('medial_tf.femur_r.force.Y',h5));
mFZ = d5(ii5,strcmp('medial_tf.femur_r.force.Z',h5));
mTX = d5(ii5,strcmp('medial_tf.femur_r.torque.X',h5));
mTY = d5(ii5,strcmp('medial_tf.femur_r.torque.Y',h5));
mTZ = d5(ii5,strcmp('medial_tf.femur_r.torque.Z',h5));

lFX = d5(ii5,strcmp('lateral_tf.femur_r.force.X',h5));
lFY = d5(ii5,strcmp('lateral_tf.femur_r.force.Y',h5));
lFZ = d5(ii5,strcmp('lateral_tf.femur_r.force.Z',h5));
lTX = d5(ii5,strcmp('lateral_tf.femur_r.torque.X',h5));
lTY = d5(ii5,strcmp('lateral_tf.femur_r.torque.Y',h5));
lTZ = d5(ii5,strcmp('lateral_tf.femur_r.torque.Z',h5));

[med_mag_force] = calc_magnitude(mFX,mFY,mFZ);
[lat_mag_force] = calc_magnitude(lFX,lFY,lFZ);

figure('color','w','units','normalized','outerposition',[0 0 1 1]);

subplot(1,2,1);
plot(t5(ii5),lat_mag_force,'b-','LineWidth',3);
set(gca,'box','off','FontSize',12);
ylabel('Force (N)');
title('Contact Force');
title('Lateral');
xlabel('Time (s)');
ylim([0 max([lat_mag_force;med_mag_force])]);

subplot(1,2,2);
plot(t5(ii5),med_mag_force,'r-','LineWidth',3);
set(gca,'box','off','FontSize',12);
ylabel('Force (N)');
title('Contact Force');
title('Medial');
xlabel('Time (s)');
ylim([0 max([lat_mag_force;med_mag_force])]);

saveas(gcf,'./cartilage_loads.fig');